<%@ WebHandler Language="VB" Class="BusinessCardGen" %>

Imports System
Imports System.Web
Imports System.Drawing

Imports Neodynamic.WebControls.ImageDraw

Public Class BusinessCardGen : Implements IHttpHandler
    
    Public Sub ProcessRequest(ByVal context As HttpContext) Implements IHttpHandler.ProcessRequest
        
        'Get the info to create the business card
        Dim fullname As String = ""
        Dim jobtitle As String = ""
        Dim addressline1 As String = ""
        Dim addressline2 As String = ""
        Dim phone As String = ""
        Dim email As String = ""
        Dim logoId As String = ""
        Dim layout As String = "Left"
        Dim cardColor As String = "White"
        
        If Not context.Request("fullname") Is Nothing Then
            fullname = context.Request("fullname")
        End If
        If Not context.Request("jobtitle") Is Nothing Then
            jobtitle = context.Request("jobtitle")
        End If
        If Not context.Request("addressline1") Is Nothing Then
            addressline1 = context.Request("addressline1")
        End If
        If Not context.Request("addressline2") Is Nothing Then
            addressline2 = context.Request("addressline2")
        End If
        If Not context.Request("phone") Is Nothing Then
            phone = context.Request("phone")
        End If
        If Not context.Request("email") Is Nothing Then
            email = context.Request("email")
        End If
        If Not context.Request("logoId") Is Nothing Then
            logoId = context.Request("logoId")
        End If
        If Not context.Request("layout") Is Nothing Then
            layout = context.Request("layout")
        End If
        If Not context.Request("color") Is Nothing Then
            cardColor = context.Request("color")
        End If
        
        
        'Create an instance of ImageDraw
        Dim imgDraw As New ImageDraw
        'Basic settings for Business Card
        imgDraw.Canvas.AutoSize = False
        imgDraw.ImageFormat = ImageDrawFormat.Png
        'Set business card size
        imgDraw.Canvas.Width = 400
        imgDraw.Canvas.Height = 250
        
        
        'Create main decorative shape element
        Dim rect1 As New RectangleShapeElement
        rect1.X = 10
        rect1.Y = 10
        rect1.Width = 380
        rect1.Height = 230
        
        rect1.Roundness = 20
        rect1.StrokeWidth = 0
        'Set background
        Dim c As Color = Color.White
        Try
            c = ColorTranslator.FromHtml(cardColor)
        Catch ex As Exception
        End Try
        rect1.Fill.BackgroundColor = c
        'Add element to output image
        imgDraw.Elements.Add(rect1)
        
        
        
        'Create top decorative shape element
        Dim rect2 As New RectangleShapeElement
        rect2.X = 20
        rect2.Y = 20
        rect2.Width = 360
        rect2.Height = 170
        rect2.Roundness = 10
        rect2.StrokeWidth = 0
        rect2.Fill.BackgroundColor = Color.White
        'Add element to output image
        imgDraw.Elements.Add(rect2)
        
        'Create bottom decorative shape element
        Dim rect3 As New RectangleShapeElement
        rect3.X = 30
        rect3.Y = 130
        rect3.Width = 340
        rect3.Height = 100
        rect3.Roundness = 10
        rect3.StrokeWidth = 1
        rect3.StrokeFill.BackgroundColor = c
        rect3.Fill.BackgroundColor = Color.White
        'Add element to output image
        imgDraw.Elements.Add(rect3)
        
        
        'Create an ImageElement to wrap the user logo
        If (logoId.Length > 0) Then
            Dim imgElemLogo As New ImageElement
            'Get user logo from Application storage in binary format
            imgElemLogo.Source = ImageSource.Binary
            imgElemLogo.SourceBinary = CType(context.Application.Item(logoId), Byte())
            'Logo Layout
            If layout = "Right" Then
                imgElemLogo.X = 40
                imgElemLogo.Y = 40
            Else
                imgElemLogo.X = 400 - (50 + 40) 'Canvas Width - (Logo Width + X Margin)
                imgElemLogo.Y = 40
            End If
            
            'Apply Resize logo
            Dim resizeLogo As New Resize
            resizeLogo.Width = 50
            resizeLogo.LockAspectRatio = LockAspectRatio.WidthBased
            imgElemLogo.Actions.Clear()
            imgElemLogo.Actions.Add(resizeLogo)
            
            'Add element to output image
            imgDraw.Elements.Add(imgElemLogo)
        End If
        
        
        
        'Create TextElement objects for each fields
        
        'Full Name TextElement
        If (fullname.Length > 0) Then
            Dim txtElemName As New TextElement
            With txtElemName
                .AutoSize = False
                .Font.Name = "Arial"
                .Font.Size = 14
                .Font.Unit = FontUnit.Point
                .Font.Bold = True
                .ForeColor = System.Drawing.Color.Black
                .Text = fullname
                .TextQuality = Drawing.Text.TextRenderingHint.AntiAliasGridFit
                .X = 40
                .Y = 40
                .Width = 320
                .Height = 20
                If layout = "Left" Then
                    .TextAlignment = ContentAlignment.MiddleLeft
                Else
                    .TextAlignment = ContentAlignment.MiddleRight
                End If
            End With
            'Add element to output image
            imgDraw.Elements.Add(txtElemName)
        End If
        
        'Job Title TextElement
        If (jobtitle.Length > 0) Then
            Dim txtElemJob As New TextElement
            With txtElemJob
                .AutoSize = False
                .Font.Name = "Arial"
                .Font.Size = 10
                .Font.Unit = FontUnit.Point
                .ForeColor = System.Drawing.Color.Black
                .Text = jobtitle
                .TextQuality = Drawing.Text.TextRenderingHint.AntiAlias
                .X = 40
                .Y = 64
                .Width = 320
                .Height = 14
                If layout = "Left" Then
                    .TextAlignment = ContentAlignment.MiddleLeft
                Else
                    .TextAlignment = ContentAlignment.MiddleRight
                End If
            End With
            'Add element to output image
            imgDraw.Elements.Add(txtElemJob)
        End If
        
        'Address Lines TextElement
        If (addressline1.Length > 0) Then
            Dim txtElemAddress As New TextElement
            With txtElemAddress
                .AutoSize = False
                .Font.Name = "Times New Roman"
                .Font.Italic = True
                .Font.Size = 11
                .Font.Unit = FontUnit.Point
                .ForeColor = System.Drawing.Color.Black
                .Text = addressline1 + vbCrLf + addressline2
                .TextQuality = Drawing.Text.TextRenderingHint.AntiAlias
                .X = 40
                .Y = 130
                .Width = 160
                .Height = 50
                If layout = "Left" Then
                    .TextAlignment = ContentAlignment.MiddleLeft
                Else
                    .TextAlignment = ContentAlignment.MiddleRight
                End If
            End With
            'Add element to output image
            imgDraw.Elements.Add(txtElemAddress)
        End If
        
        'Phone and Email TextElement
        If (phone.Length > 0 OrElse email.Length > 0) Then
            Dim txtElemPhone As New TextElement
            With txtElemPhone
                .AutoSize = False
                .Font.Name = "Georgia"
                .Font.Size = 10
                .Font.Unit = FontUnit.Point
                .ForeColor = System.Drawing.Color.Black
                .Text = "Phone: " + phone + vbCrLf + email
                .TextQuality = Drawing.Text.TextRenderingHint.AntiAlias
                .X = 200
                .Y = 180
                .Width = 160
                .Height = 50
                If layout = "Right" Then
                    .TextAlignment = ContentAlignment.MiddleLeft
                Else
                    .TextAlignment = ContentAlignment.MiddleRight
                End If
            End With
            'Add element to output image
            imgDraw.Elements.Add(txtElemPhone)
        End If
        
        
        
        'Render the output image
        context.Response.ContentType = "image/png"
        context.Response.BinaryWrite(imgDraw.GetOutputImageBinary())
        
    End Sub
 
    Public ReadOnly Property IsReusable() As Boolean Implements IHttpHandler.IsReusable
        Get
            Return False
        End Get
    End Property

End Class